/*
 * similar to SwingWorker in Java SE 6
 */


/*
 *
 */
package installer.common;


/*
 *
 */
import java.awt.EventQueue;


/*
 * FIXME: i don't really like how this has to be inherited;
 *        it should just take a (double-)functor as an argument
 */
public abstract class GUIWorker
{
    /*
     * method to be run in a new thread
     */
    protected abstract void doInBackground();


    /*
     * method to be run in the AWT-Event thread,
     * after doInBackground() has finished
     */
    protected abstract void done();


    /*
     * N.B.: this code is less ridiculous than it looks at first glance
     */
    public void execute()
    {
        (new Thread(new Runnable() {
                public void run()
                {
                    doInBackground();
                    EventQueue.invokeLater(new Runnable() {
                            public void run()
                            {
                                done();
                            }
                        });
                }
            })).start();
    }
}

