/*
 *
 */


/*
 *
 */
import javax.swing.Box;
import javax.swing.ButtonGroup;
import javax.swing.JOptionPane;
import javax.swing.JPasswordField;
import javax.swing.JRadioButton;

import installer.common.Controller;
import installer.common.NativeGUI;


/*
 *
 */
public class LinuxNativeGUI implements NativeGUI
{
    /*
     * FIXME: make a choice between su and sudo
     */
    public Controller.Password showRootPasswordPrompt()
    {
        JPasswordField passwordField;
        Box mainBox;
        JRadioButton sudoButton, suButton;
        ButtonGroup suTypeGroup;
        String dialogTitle;
        String dialogQuestion;
        int result;


        // FIXME: improve these messages!
        dialogTitle = "Superuser Access Required";
        dialogQuestion = "Please enter your password for superuser access:";

        //
        mainBox = Box.createVerticalBox();
        sudoButton = new JRadioButton("Use sudo");
        suButton = new JRadioButton("Use su");
        passwordField = new JPasswordField();

        //
        suTypeGroup = new ButtonGroup();
        suTypeGroup.add(sudoButton);
        suTypeGroup.add(suButton);
        sudoButton.setSelected(true);

        //
        mainBox.add(sudoButton);
        mainBox.add(suButton);
        mainBox.add(passwordField);

        //
        // FIXME: pass the frame as the first arg. here
        result = JOptionPane.showConfirmDialog(null,
                                               new Object[] { dialogQuestion, mainBox },
                                               // new Object[] { dialogQuestion, passwordField },
                                               dialogTitle,
                                               JOptionPane.OK_CANCEL_OPTION,
                                               JOptionPane.QUESTION_MESSAGE);

        //
        if (result == JOptionPane.OK_OPTION)
        {
            Controller.Password.Method suMethod;

            if (sudoButton.isSelected())
            {
                suMethod = Controller.Password.Method.SUDO;
            }
            else if (suButton.isSelected())
            {
                suMethod = Controller.Password.Method.SU;
            }
            else
            {
                // this should never happen
                suMethod = Controller.Password.Method.SUDO;
            }
            // suMethod = Controller.Password.Method.SUDO;

            // FIXME: is this a security hazard?
            return new Controller.Password(passwordField.getPassword(),
                                           suMethod);
        }
        else
        {
            return null;
        }
    }
}