/*
 * this is (probably) a placeholder before moving to IzPack
 */


/*
 *
 */
package installer.common;


/*
 *
 */
import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPasswordField;
import javax.swing.JScrollBar;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;


/*
 *
 */
public class InstallerDisplay
{
    /*
     *
     */
    protected JButton okButton;
    protected JFrame frame;
    protected JTextArea textArea;
    protected JScrollPane textAreaScrollPane;


    /*
     *
     */
    public InstallerDisplay(String title)
    {
        frame = new JFrame(title);
        textArea = new JTextArea();
        textAreaScrollPane = new JScrollPane(textArea);
        okButton = new JButton("OK");

        //okButton.setEnabled(false);
        okButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent event)
                {
                    // if this is called, we know that when the frame is
                    // disposed, it will cause the program to exit
                    frame.setVisible(false);
                    frame.dispose();
                }
            });

        frame.getContentPane().add(textAreaScrollPane, BorderLayout.CENTER);
        frame.getContentPane().add(okButton, BorderLayout.SOUTH);

        frame.setSize(800, 500);
        //frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);

        enableQuitting(false);
    }


    /*
     *
     */
    public void addLine(String lineText)
    {
        // FIXME: use java property line.separator?
        textArea.append(lineText + "\n");
    }


    /*
     * FIXME: this *always* scrolls down; we would only like to scroll down when the bar is
     *        already at the bottom
     */
    public void addText(String text)
    {
        boolean paneIsScrolledToBottom;
        JScrollBar vBar;


        // FIXME: this doesn't work right
        vBar = textAreaScrollPane.getVerticalScrollBar();
        paneIsScrolledToBottom = vBar.getValue() + vBar.getVisibleAmount() == vBar.getMaximum();

        //
        textArea.append(text);

        //
        textArea.setCaretPosition(textArea.getDocument().getLength());
    }


    /*
     *
     */
    public void enableQuitting(boolean enable)
    {
        if (enable)
        {
            frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        }
        else
        {
            frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
        }

        okButton.setEnabled(enable);
    }


    /*
     *
     */
    public void hide()
    {
        frame.setVisible(false);
    }


    /*
     * display a dialog asking for the user's password;
     * return the password as a string, if the user clicks "OK;"
     * if the user clicks "Cancel," return null.
     *
     * FIXMEFIXME: this needs to check whether the password is valid!!!
     */
    public String promptForSudoPassword()
    {
        JPasswordField passwordField;
        String dialogTitle;
        String dialogQuestion;
        int result;


        // FIXME: improve these messages!
        dialogTitle = "Superuser Password Required";
        dialogQuestion = "Please enter your password for superuser access:";

        //
        passwordField = new JPasswordField();

        //
        result = JOptionPane.showConfirmDialog(null,
                                               new Object[] { dialogQuestion, passwordField },
                                               dialogTitle,
                                               JOptionPane.OK_CANCEL_OPTION,
                                               JOptionPane.QUESTION_MESSAGE);

        //
        if (result == JOptionPane.OK_OPTION)
        {
            // FIXME: is this a security hazard?
            return new String(passwordField.getPassword());
        }
        else
        {
            return null;
        }
    }


    /*
     *
     */
    public void show()
    {
        frame.setVisible(true);
    }

}

