/*
 *
 */


/*
 *
 */
import java.lang.Class;
import java.lang.ClassLoader;
import java.lang.reflect.InvocationTargetException;
import wfdb.*;


/*
 *
 */
public class time2secMatlab
{
    /*
     *
     */
    static
    {
        try
        {
            Class nativeLibLoader
                = ClassLoader.getSystemClassLoader().loadClass("NativeLibLoader");
            nativeLibLoader.getMethod("loadLibraries", null).invoke(null, null);
        }
        catch (ClassNotFoundException ex)
        {
        }
        catch (NoSuchMethodException ex)
        {
        }
        catch (IllegalAccessException ex)
        {
        }
        catch (InvocationTargetException ex)
        {
        }
    }


    /*
     *
     */
    public static double time2sec(String time,
                                  String recordName)  // -r
    {
        double t;


        //
        if (recordName != null)
        {
            wfdb.isigopen(recordName, null, 0);
            t = wfdb.strtim(time);
            t = (t < 0) ? -t : t;
            t /= wfdb.sampfreq(null);
        }
        else
        {
            wfdb.setsampfreq(1000.0);
            t = wfdb.strtim(time) / 1000.0;
        }

        //
        wfdb.wfdbquit();
        return t;
    }

}

