/*
 *
 */


/*
 *
 */
import java.lang.Class;
import java.lang.ClassLoader;
import java.lang.reflect.InvocationTargetException;
import wfdb.*;


/*
 *
 */
public class wfdbwhichMatlab
{
    /*
     *
     */
    static
    {
        try
        {
            Class nativeLibLoader
                = ClassLoader.getSystemClassLoader().loadClass("NativeLibLoader");
            nativeLibLoader.getMethod("loadLibraries", null).invoke(null, null);
        }
        catch (ClassNotFoundException ex)
        {
        }
        catch (NoSuchMethodException ex)
        {
        }
        catch (IllegalAccessException ex)
        {
        }
        catch (InvocationTargetException ex)
        {
        }
    }


    /*
     * FIXME: substitutedRecord needs to be tested more extensively
     */
    public static String wfdbwhichWithSubst(String filename,
                                            String substitutedRecord) // -r
    {
        String fullPathname;


        if (substitutedRecord == null)
        {
            fullPathname = wfdb.wfdbfile(filename, null);
        }
        else
        {
            wfdb.isigopen(substitutedRecord, null, 0);
            fullPathname = wfdb.wfdbfile(filename, null);
        }

        wfdb.wfdbquit();
        return fullPathname;
    }


    /*
     * The man page for wfdbwhich indicates that a substitutedRecord may be
     * used here, as it is used in the wfdbwhich() method above -- that is,
     * that the following CLI app. call template is valid (the "record" arg.
     * preceded by "-r" is what I call "substitutedRecord"):
     *
     * wfdbwhich [ -r record ] file-type record
     *
     * The source code, though, disagrees; the substitutedRecord is only
     * when providing a filename, not a file-type and record.
     */
    public static String wfdbwhich(String filetype,
                                   String recordName)
    {
        String fullPathname;

        
        wfdb.wfdbquiet();
        wfdb.isigopen(recordName, null, 0);
        fullPathname = wfdb.wfdbfile(filetype, recordName);

        wfdb.wfdbquit();
        return fullPathname;
    }

}

