/*
 *
 */


/*
 *
 */
import java.lang.Class;
import java.lang.ClassLoader;
import java.lang.reflect.InvocationTargetException;
import wfdb.*;


/*
 *
 */
public class wrannMatlab
{
    /*
     *
     */
    static
    {
        try
        {
            Class nativeLibLoader
                = ClassLoader.getSystemClassLoader().loadClass("NativeLibLoader");
            nativeLibLoader.getMethod("loadLibraries", null).invoke(null, null);
        }
        catch (ClassNotFoundException ex)
        {
        }
        catch (NoSuchMethodException ex)
        {
        }
        catch (IllegalAccessException ex)
        {
        }
        catch (InvocationTargetException ex)
        {
        }
    }


    /*
     *
     */
    public static void wrann(Annotation[] annotations,
                             String recordName,         // -r
                             String annotatorName)      // -a
    {
        WFDB_Anninfo ai;
        WFDB_Annotation annot;
        int i;


        //
        if (recordName == null || annotatorName == null || annotations == null)
        {
            // FIXME: throw exception
            wfdb.wfdbquit();
            return;
        }

        //
        ai = new WFDB_Anninfo();
        annot = new WFDB_Annotation();

        //
        wfdb.setafreq(wfdb.sampfreq(recordName));
        ai.setName(annotatorName);
        ai.setStat(wfdb.WFDB_WRITE);
        if (wfdb.annopen(recordName, ai, 1) < 0)
        {
            // FIXME: throw exception
            wfdb.wfdbquit();
            return;
        }
        
        //
        for (i = 0; i < annotations.length; ++i)
        {
            // note: annotations[i].timeInSeconds is not used

            annot.setAnntyp(wfdb.strann(annotations[i].typeMnemonic));
            annot.setTime(annotations[i].sampleNumber);
            annot.setSubtyp(annotations[i].subtype);
            annot.setChan(annotations[i].chan);
            annot.setNum(annotations[i].num);

            if (annotations[i].auxInfo == null)
            {
                annot.setAux(null);
            }
            else
            {
                // the first byte needs to be the length of the string
                annot.setAux(((char)annotations[i].auxInfo.length()) + annotations[i].auxInfo);
            }

            wfdb.putann(0, annot);
        }

        //
        wfdb.wfdbquit();
        return;
    }

}

